"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _constants = require("./constants");

const init = async pool => {
  switch (pool.promise[_constants.symbol].phase) {
    case _constants.Phases.SAGA:
    case _constants.Phases.PROPERTIES:
      {
        return await pool.initSaga(pool);
      }

    case _constants.Phases.READ_MODEL:
    case _constants.Phases.RESOLVER:
    case _constants.Phases.AS:
      {
        return await pool.initReadModel(pool);
      }

    default:
      {
        throw new TypeError();
      }
  }
};

var _default = init;
exports.default = _default;
//# sourceMappingURL=init.js.map